#ifndef DATA_EMAIL_H
#define DATA_EMAIL_H

#include "../Data.h"

namespace Data {
  class EMail : public ::Base::Data
  {
  public:
    class EMailType : public ::Base::Type
    {
    public:
      enum Attribute
      {
        email  = 0
      };

    public:
      EMailType();

      unsigned long GetMaxAttribute() const;
      bool IsPrimaryType() const;

      ::Base::DataPtr Create() const;
    };

  public:
    static EMailType *emailType;

  public:
    std::wstring email;

  public:
    EMail();

    std::wstring GetDisplayText() const;

    void SetAttribute(::Base::Id id, const std::wstring& value);
    std::wstring GetAttribute(::Base::Id id) const;
  };

  typedef EMail *EMailPtr;
}

#endif
